#ifndef KYSECURITY_BOX_H
#define KYSECURITY_BOX_H

#include <linux/types.h>
#include <linux/fs.h>

#define BOX_VERSION "2.0"

#ifndef XATTR_SECURITY_PREFIX
#define	XATTR_SECURITY_PREFIX "security."
#endif

#define XATTR_BOX_SUFFIX "boxadm"
#define XATTR_NAME_BOX (XATTR_SECURITY_PREFIX XATTR_BOX_SUFFIX)

#define ATTR_BOX_DIR	1U

/* box type: encrypted/decrypted/none */
#define BOX_ENCRYPTED	0x0001
#define BOX_DECRYPTED	0x0002
#define BOX_NONE	0x0004	/* normal box, non ecryptfs */

struct box_struct {
	uint8_t box_attr;
	uid_t box_uid;
	unsigned box_type;
};

#define  IS_BOX_DIR(data)	((data).box_attr == ATTR_BOX_DIR)
#define  IS_NOT_BOX(data)	(!IS_BOX_DIR(data))

int box_filter_check(unsigned long ino, bool is_box,
		struct inode *parent, const char *name);
#endif
