/* SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note */

#ifndef __PHYS_RULE_H__
#define __PHYS_RULE_H__

struct phys_rule_struct;

extern struct phys_rule_struct *phys_rule_find(unsigned long pa);
extern int phys_rule_set(unsigned long pa, unsigned long size,
		unsigned long attr, unsigned long status);
extern int phys_rule_remove(struct phys_rule_struct *rule);
extern int phys_rule_remove_range(unsigned long pa, unsigned long size);
extern int phys_rule_status_change(struct phys_rule_struct *rule,
				unsigned long status);
extern int phys_rule_range_status_change(unsigned long pa,
				unsigned long size, unsigned long status);
extern int phys_rule_fetch_log_cnt(unsigned long pa, unsigned long size,
				unsigned int *log_nr);
extern int phys_rule_fetch_log_entry(unsigned long pa, unsigned long size,
		unsigned long limit, unsigned long *buf);
extern int rcd_init_key(struct dimm_key_struct keys[]);
extern int rcd_update_random_key(struct dimm_key_struct keys[]);
extern int rcd_sync_random_key(struct dimm_key_struct keys[]);
#endif
