/* SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note */

#ifndef __PLATFORM_COMMON_H__
#define __PLATFORM_COMMON_H__	1

#include <linux/compiler.h>
#include <linux/stddef.h>
#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/list.h>

#define DIMM_DEV_VENDOR(vid_high, vid_low)	((vid_high) << 0x10 | (vid_low))

union common_ddr_format {
	struct {
		/* first 4 bytes */
		unsigned int col:10;	/* COL[0:9] */
		unsigned int row:18;	/* ROW[0:17] */
		unsigned int ba:2;	/* BA[0:1] */
		unsigned int bg:2;	/* BG[0:1] */

		/* second 4 bytes */
		unsigned int rank:2;	/* rank[0:1] */
		unsigned int type:1;	/* TYPE[0] */
		unsigned int rsv0:29;	/* reserve bits */
	};
	unsigned long data;
};

struct tagged_ddr_format {
	union common_ddr_format ddr;
	long id;		/* MUST be rcd_device->id */
};

extern int platform_system_range_decode(unsigned long sys_start,
					unsigned long sys_end,
					struct list_head *rcd_rule_head,
					unsigned long gran);

struct rcd_device;
extern long platform_reverse_address(union common_ddr_format *ddr,
				     struct rcd_device *rcd_dev,
				     unsigned long *pa);

extern long platform_reverse_address_tagged(
					struct tagged_ddr_format *tagged_ddr,
					unsigned long *pa);
extern int platform_forward_address(unsigned long pa,
			struct tagged_ddr_format *tagged_ddr);
extern int platform_mem_cfg_compliance(void *cfg_tbl, void *__mem_cfg);
#endif
