
function usage()
{
	echo -e "`basename $0` <ARCH> \n<ARCH>: x86, arm64, mips"
}

#used to find the constant kabi list, such as comparing the compatible KABI between SP2 and SP3
function compare_kabi()
{
	LIST_FILE_1=$1
	LIST_FILE_2=$2

	if ! [ -f "$LIST_FILE_1" ] || ! [ -f "$LIST_FILE_2" ]; then
		exit 1;
	fi
	while read oneline
		do grep "$oneline" $LIST_FILE_1;
	done < $LIST_FILE_2 | awk '{print $2}' | sort
}

if [ -z "$1" ]; then
        echo "Terminating..."
        usage && exit 1
fi

LIST_ARCH=""
SYM_ARCH=""
case $1 in
	x86)
		LIST_ARCH="x86_64"
		SYM_ARCH="x86_64";;
	arm64)
		LIST_ARCH="aarch64"
		SYM_ARCH="aarch64";;
	mips)
		LIST_ARCH="mips"
		SYM_ARCH="mips64el";;
	*)
		usage && exit 1;;
esac

rm -rf Module.kabi.new kabi_whitelist_notexist

if ! [ -e Module.symvers ]; then
	echo "no Module.symvers found, please compile kernel for $LIST_ARCH firstly!";
	exit 1;
fi

for list in `cat rpmbuild/SOURCES/kabi-whitelists/kabi_whitelist_${LIST_ARCH} | sed -n '1!p'`
do
	item=$(cat Module.symvers | sed -n "/\t${list}\t/p");
	if [ -z "$item" ]; then
		echo $list not found in Module.symvers;
		echo $list >> kabi_whitelist_notexist
	else
		printf "${item}\n" >> Module.kabi.new;
	fi;
done

mv Module.kabi.new rpmbuild/SOURCES/Module.kabi_${SYM_ARCH}

if [ -e kabi_whitelist_notexist ]; then
	echo "some symbol listed in file kabi_whitelist_notexist was not found in Module.symvers."
	echo "please consider removing it from rpmbuild/SOURCES/kabi-whitelists/kabi_whitelist_${LIST_ARCH}"
fi
